{
  This file was automatically generated on 2012-09-28.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletGPS;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_GPS_FUNCTION_GET_COORDINATES = 1;
  BRICKLET_GPS_FUNCTION_GET_STATUS = 2;
  BRICKLET_GPS_FUNCTION_RESTART = 3;
  BRICKLET_GPS_FUNCTION_SET_COORDINATES_CALLBACK_PERIOD = 4;
  BRICKLET_GPS_FUNCTION_GET_COORDINATES_CALLBACK_PERIOD = 5;
  BRICKLET_GPS_FUNCTION_SET_STATUS_CALLBACK_PERIOD = 6;
  BRICKLET_GPS_FUNCTION_GET_STATUS_CALLBACK_PERIOD = 7;
  BRICKLET_GPS_CALLBACK_COORDINATES = 8;
  BRICKLET_GPS_CALLBACK_STATUS = 9;

type
  TArray0To1OfUInt16 = array [0..1] of word;

  TBrickletGPSNotifyCoordinates = procedure(const ns: char; const latitude: TArray0To1OfUInt16; const ew: char; const longitude: TArray0To1OfUInt16; const pdop: word; const hdop: word; const vdop: word) of object;
  TBrickletGPSNotifyStatus = procedure(const fix: byte; const satellitesView: byte; const satellitesUsed: byte; const speed: word; const course: word; const date: longword; const time: longword; const altitude: smallint; const altitudeAccuracy: smallint) of object;

  /// <summary>
  ///  Device for receiving GPS position
  /// </summary>
  TBrickletGPS = class(TDevice)
  private
    coordinatesCallback: TBrickletGPSNotifyCoordinates;
    statusCallback: TBrickletGPSNotifyStatus;
  protected
    procedure CallbackWrapperCoordinates(const packet: TByteArray); virtual;
    procedure CallbackWrapperStatus(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid_: string);

    /// <summary>
    ///  
    /// </summary>
    procedure GetCoordinates(out ns: char; out latitude: TArray0To1OfUInt16; out ew: char; out longitude: TArray0To1OfUInt16; out pdop: word; out hdop: word; out vdop: word); virtual;

    /// <summary>
    ///  
    /// </summary>
    procedure GetStatus(out fix: byte; out satellitesView: byte; out satellitesUsed: byte; out speed: word; out course: word; out date: longword; out time: longword; out altitude: smallint; out altitudeAccuracy: smallint); virtual;

    /// <summary>
    ///  
    /// </summary>
    procedure Restart(const restartType: byte); virtual;

    /// <summary>
    ///  
    /// </summary>
    procedure SetCoordinatesCallbackPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickletGPS.TBrickletGPS.SetCoordinatesCallbackPeriod"/>.
    /// </summary>
    function GetCoordinatesCallbackPeriod: longword; virtual;

    /// <summary>
    ///  
    /// </summary>
    procedure SetStatusCallbackPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickletGPS.TBrickletGPS.GetStatusCallbackPeriod"/>.
    /// </summary>
    function GetStatusCallbackPeriod: longword; virtual;

    /// <summary>
    ///  
    /// </summary>
    property OnCoordinates: TBrickletGPSNotifyCoordinates read coordinatesCallback write coordinatesCallback;

    /// <summary>
    ///  
    /// </summary>
    property OnStatus: TBrickletGPSNotifyStatus read statusCallback write statusCallback;
  end;

implementation

constructor TBrickletGPS.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'GPS Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
  callbackWrappers[BRICKLET_GPS_CALLBACK_COORDINATES] := {$ifdef FPC}@{$endif}CallbackWrapperCoordinates;
  callbackWrappers[BRICKLET_GPS_CALLBACK_STATUS] := {$ifdef FPC}@{$endif}CallbackWrapperStatus;
end;

procedure TBrickletGPS.GetCoordinates(out ns: char; out latitude: TArray0To1OfUInt16; out ew: char; out longitude: TArray0To1OfUInt16; out pdop: word; out hdop: word; out vdop: word);
var request, response: TByteArray; i: longint;
begin
  request := CreateRequestPacket(stackID, BRICKLET_GPS_FUNCTION_GET_COORDINATES, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_GPS_FUNCTION_GET_COORDINATES, response);
  ns := LEConvertCharFrom(4, response);
  for i := 0 to 1 do latitude[i] := LEConvertUInt16From(5 + (i * 2), response);
  ew := LEConvertCharFrom(9, response);
  for i := 0 to 1 do longitude[i] := LEConvertUInt16From(10 + (i * 2), response);
  pdop := LEConvertUInt16From(14, response);
  hdop := LEConvertUInt16From(16, response);
  vdop := LEConvertUInt16From(18, response);
end;

procedure TBrickletGPS.GetStatus(out fix: byte; out satellitesView: byte; out satellitesUsed: byte; out speed: word; out course: word; out date: longword; out time: longword; out altitude: smallint; out altitudeAccuracy: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_GPS_FUNCTION_GET_STATUS, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_GPS_FUNCTION_GET_STATUS, response);
  fix := LEConvertUInt8From(4, response);
  satellitesView := LEConvertUInt8From(5, response);
  satellitesUsed := LEConvertUInt8From(6, response);
  speed := LEConvertUInt16From(7, response);
  course := LEConvertUInt16From(9, response);
  date := LEConvertUInt32From(11, response);
  time := LEConvertUInt32From(15, response);
  altitude := LEConvertInt16From(19, response);
  altitudeAccuracy := LEConvertInt16From(21, response);
end;

procedure TBrickletGPS.Restart(const restartType: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_GPS_FUNCTION_RESTART, 5);
  LEConvertUInt8To(restartType, 4, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletGPS.SetCoordinatesCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_GPS_FUNCTION_SET_COORDINATES_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletGPS.GetCoordinatesCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_GPS_FUNCTION_GET_COORDINATES_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_GPS_FUNCTION_GET_COORDINATES_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletGPS.SetStatusCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_GPS_FUNCTION_SET_STATUS_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletGPS.GetStatusCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_GPS_FUNCTION_GET_STATUS_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_GPS_FUNCTION_GET_STATUS_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletGPS.CallbackWrapperCoordinates(const packet: TByteArray);
var ns: char; latitude: TArray0To1OfUInt16; ew: char; longitude: TArray0To1OfUInt16; pdop: word; hdop: word; vdop: word;
begin
  if (Assigned(coordinatesCallback)) then begin
    ns := LEConvertCharFrom(4, packet);
    for i := 0 to 1 do latitude[i] := LEConvertUInt16From(5 + (i * 2), packet);
    ew := LEConvertCharFrom(9, packet);
    for i := 0 to 1 do longitude[i] := LEConvertUInt16From(10 + (i * 2), packet);
    pdop := LEConvertUInt16From(14, packet);
    hdop := LEConvertUInt16From(16, packet);
    vdop := LEConvertUInt16From(18, packet);
    coordinatesCallback(ns, latitude, ew, longitude, pdop, hdop, vdop);
  end;
end;

procedure TBrickletGPS.CallbackWrapperStatus(const packet: TByteArray);
var fix: byte; satellitesView: byte; satellitesUsed: byte; speed: word; course: word; date: longword; time: longword; altitude: smallint; altitudeAccuracy: smallint;
begin
  if (Assigned(statusCallback)) then begin
    fix := LEConvertUInt8From(4, packet);
    satellitesView := LEConvertUInt8From(5, packet);
    satellitesUsed := LEConvertUInt8From(6, packet);
    speed := LEConvertUInt16From(7, packet);
    course := LEConvertUInt16From(9, packet);
    date := LEConvertUInt32From(11, packet);
    time := LEConvertUInt32From(15, packet);
    altitude := LEConvertInt16From(19, packet);
    altitudeAccuracy := LEConvertInt16From(21, packet);
    statusCallback(fix, satellitesView, satellitesUsed, speed, course, date, time, altitude, altitudeAccuracy);
  end;
end;

end.
